from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallPayment.PaymentInformation import PaymentInformation
from Products.SFUAuthorizeNetPlugin.config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
from zLOG import LOG, INFO, DEBUG

AuthorizeNetInfoSchema = BaseSchema.copy()

schema= AuthorizeNetInfoSchema + Schema((
    StringField(
        'mungedCCNumber',
        widget=StringWidget(
            label="Credit Card Number",
            description="The Credit Card number",
        ),
    ),
),
)

class AuthorizeNetPaymentInformation(PaymentInformation,BaseContent):
    """Payment information for AuthorizeNet
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(PaymentInformation,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)

    portal_type = meta_type = archetype_name = 'AuthorizeNetPaymentInformation'

    global_allow               = 1
    #content_icon               = 'AuthorizeNetPaymentInformation.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "AuthorizeNetPaymentInformation"
    typeDescMsgId              = 'description_edit_authorizenetpaymentinformation'

    schema = BaseSchema + \
             getattr(PaymentInformation,'schema',Schema(())) + schema
             
    security.declarePublic('processPayment')
    def processPayment(self):
        """redirect to the credit card form on site
        """
        self.changeState('initializeProcessing')
        return self.REQUEST.RESPONSE.redirect(self.portal_url().replace('http:', 'https:') + '/creditcard')
                                      
    def paymentSuccess(self):
        """Confirm payment and send to afterCheckout
        """
        self.setConfirmed(True)
        self.changeState('successProcessing')
        cardnumber = self.REQUEST.SESSION.get('cardnumber','')
        self.setMungedCCNumber(cardnumber) # set the CC Number in the payment info
        
        return self.REQUEST.RESPONSE.redirect(self.aq_parent.absolute_url()+ \
                '/afterCheckout')
    
    ## this method should be in PaymentInformation.py                                  
    def changeState(self,transition):
        wft=getToolByName(self,'portal_workflow')
        wft.doActionFor(self,transition)

    def setMungedCCNumber(self,value):
        """setting munged credit card number
        """
        value = len(value[:-4]) * '*' + value[-4:]
        self.getField('mungedCCNumber').set(self,value)

registerType(AuthorizeNetPaymentInformation,PROJECTNAME)
FactoryRegistry.registerMallFactory('AuthorizeNetPaymentInformation', AuthorizeNetPaymentInformation)



