from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallRegistry.IPaymentSettings import IPaymentSettings
from Products.SFUAuthorizeNetPlugin.config import *
from Products.PloneMallRegistry.IRedirectingPaymentMethod import IRedirectingPaymentMethod

AuthNetSchema = BaseSchema.copy()

schema = AuthNetSchema + Schema((
    StringField(
        'xLogin',
        required=1,
        widget=StringWidget(
            label='x_login',
            description='Enter your username.',
        ),
    ),
    StringField(
        'xTranKey',
        required=1,
        widget=StringWidget(
            label='x_tran_key',
            description='Enter your transaction key.',
        ),
    ),
    StringField(
        'xVersion',
        default = '3.1',
        required=1,
        widget=StringWidget(
            label='x_version',
            description='Enter the version number.',
        ),
    ),
    BooleanField(
        'xTestRequest',
        default = True,
        widget=BooleanWidget(
            label='x_test_request',
            description="""Check this box to enter test mode.<br /><p style="color: red;">NOTE: IF TEST MODE IS SET TO TRUE IN THE MERCHANT INTERFACE THEN THIS WILL NOT CHANGE IT.  You will have to set the test mode to FALSE then you will be able to toggle this setting here.</p>""",
        ),
    ),
    BooleanField(
        'xEmailCustomer',
        default = True,
        widget=BooleanWidget(
            label='x_email_customer',
            description='Check this box if you want authorize.net to send a confirmation email to the customer.',
        ),
    ),
    StringField('payment_method',
        widget=SelectionWidget
        (
            label='Payment_method',
            label_msgid='PloneMallPayment_label_payment_method',
            description='Enter a value for payment_method.',
            description_msgid='PloneMallPayment_help_payment_method',
            i18n_domain='PloneMallPayment',
        ),
        vocabulary='listRedirectingPaymentMethods',
    ),
),
)

class AuthorizeNetSettings(BaseContent):
    """
    <p>AuthorizeNet Payment Settings</p>
    """

    schema = schema
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IPaymentSettings,)
    portal_type = meta_type = archetype_name = 'AuthorizeNetSettings'

    global_allow               = 1
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "AuthorizeNetSettings"
    typeDescMsgId              = 'description_edit_authorizenetsettings'

    def listRedirectingPaymentMethods(self):
        """
        
        """
        return self.portal_mall_registry.getSupportedFactoryNames(IRedirectingPaymentMethod)
        
registerType(AuthorizeNetSettings,PROJECTNAME)
