##########
# (c) 2003 - Six Feet Up. All Rights Reserved.
##########
""" SFUCreditCard Tool.

$Id: CreditCardTool.py 379 2005-11-18 23:01:48Z clayton $
"""


from AccessControl import ClassSecurityInfo
from Acquisition import aq_inner, aq_parent
from Globals import DTMLFile
from Globals import InitializeClass
from OFS.SimpleItem import SimpleItem
import os

from Products.CMFCore.utils import getToolByName
from Products.CMFCore.ActionProviderBase import ActionProviderBase
from Products.CMFCore.CMFCorePermissions import ManagePortal
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.utils import _dtmldir
from Products.CMFCore.utils import UniqueObject
from zLOG import LOG, INFO, ERROR, PROBLEM, DEBUG

from AccessControl import ModuleSecurityInfo

from AuthorizeNetPayment import AuthorizeNetPayment

class CreditCardTool(UniqueObject, SimpleItem, ActionProviderBase):
    """ CMF Credit Card Tool.
    """

    __implements__ = (ActionProviderBase.__implements__,)

    id = 'portal_creditcard'
    meta_type = 'Credit Card Tool'
    _actions = ()

    security = ClassSecurityInfo()
    security.declareObjectProtected(View)

    manage_options = ( ActionProviderBase.manage_options
                     + ( {'label':'Overview',
                          'action':'manage_overview'}
                       ,
                       )
                     + SimpleItem.manage_options
                     )

    #
    #   ZMI methods
    #
    security.declareProtected(ManagePortal, 'manage_overview')
    manage_overview = DTMLFile('dtml/explainCCTool', globals())

    security.declarePublic('doAuthCapture')
    def doAuthCapture(self, REQUEST):
        """ Process an Authorization and Capture.
        """
        portal = getToolByName(self, 'portal_url').getPortalObject()
        #LOG("CreditCardTool",INFO,"the test mode in CCTool -> " + str(REQUEST['test']))
        
        payment = AuthorizeNetPayment( merchant = REQUEST['x_login']
                                     , tran_key = REQUEST['x_tran_key']
                                     , first_name = REQUEST['first_name']
                                     , last_name = REQUEST['last_name']
                                     , address = REQUEST['address1']
                                     , city = REQUEST['city']
                                     , state = REQUEST['home_state']
                                     , country = REQUEST['country']
                                     , zip = REQUEST['zip']
                                     , ship_first_name = REQUEST['first_name']
                                     , ship_last_name = REQUEST['last_name']
                                     , ship_address = REQUEST['ship_address1']
                                     , ship_city = REQUEST['ship_city']
                                     , ship_state = REQUEST['ship_home_state']
                                     , ship_country = REQUEST['ship_country']
                                     , ship_zip = REQUEST['ship_zip']
                                     , email = REQUEST['email']
                                     , phone = REQUEST['phone']
                                     , company = REQUEST['company']
                                     , customer_ip = REQUEST['customer_ip']
                                     , card = REQUEST['card']
                                     , expires = REQUEST['expires']
                                     , test = REQUEST['test']
                                     , version = REQUEST['version']
                                     , email_customer = REQUEST['x_email_customer']
                                     , invoice_number = REQUEST['x_invoice_num']
                                     )
        payment.charge(REQUEST['amount'], description = REQUEST['description'])
        return payment.result, payment.error
        

    security.declarePrivate('doAuthOnly')
    def doAuthOnly(self):
        """ Process an Authorization Only.
        """
        raise NotImplementedError

    security.declarePrivate('doCaptureOnly')
    def doCaptureOnly(self):
        """ Process a Capture Only.
        """
        raise NotImplementedError

    security.declarePrivate('doCredit')
    def doCredit(self):
        """ Process an account Credit.
        """
        raise NotImplementedError

    security.declarePrivate('doVoid')
    def doVoid(self):
        """ Process a Void transaction.
        """
        raise NotImplementedError

    security.declarePrivate('doPriorAuthCapture')
    def doPriorAuthCapture(self):
        """ Process a Prior Authorization Capture.
        """
        raise NotImplementedError

InitializeClass(CreditCardTool)
