import os.path
import sys
from StringIO import StringIO

from App.Common import package_home
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.utils import manage_addTool
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from zExceptions import NotFound, BadRequest

from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
try:
    from Products.Archetypes.lib.register import listTypes
except ImportError:
    from Products.Archetypes.public import listTypes
from Products.SFUAuthorizeNetPlugin.config import PROJECTNAME
from Products.SFUAuthorizeNetPlugin import product_globals as GLOBALS

def install(self):
    """ External Method to install PloneMallOrder """
    out = StringIO()
    print >> out, "Installation log of %s:" % PROJECTNAME

    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    install_subskin(self, out, GLOBALS)

    #autoinstall tools
    portal = getToolByName(self,'portal_url').getPortalObject()
    for t in ['Credit Card Tool']:
        try:
            portal.manage_addProduct[PROJECTNAME].manage_addTool(t)
        except BadRequest:
            # if an instance with the same name already exists this error will
            # be swallowed. Zope raises in an unelegant manner a 'Bad Request' error
            pass
        except:
            e = sys.exc_info()
            if e[0] != 'Bad Request':
                raise
    #hide tools in the navigation
    portalProperties = getToolByName(self, 'portal_properties', None)
    if portalProperties is not None:
        navtreeProperties = getattr(portalProperties, 'navtree_properties', None)
        if navtreeProperties:
            navtreeProperties.idsNotToList = list(navtreeProperties.idsNotToList) + \
                                  [toolname for toolname in ['portal_creditcard'] \
                                            if toolname not in navtreeProperties.idsNotToList]

    ## set workflow for auth net info
    wft = getToolByName(self,'portal_workflow')
    wft.setChainForPortalTypes( ['AuthorizeNetPaymentInformation'],'plonemall_redirecting_payment_workflow')

    #if install:
    #    print >>out,'Custom Install:'
    #    res = install(self)
    #    if res:
    #        print >>out,res
    #    else:
    #        print >>out,'no output'
    #else:
    #    print >>out,'no custom install'
    
    return out.getvalue()

def uninstall(self):
    out = StringIO()

    # unhide tools
    portalProperties = getToolByName(self, 'portal_properties', None)
    if portalProperties is not None:
        navtreeProperties = getattr(portalProperties, 'navtree_properties', None)
        if navtreeProperties:
            navtreeProperties.idsNotToList = list(navtreeProperties.idsNotToList)
            for toolname in [toolname for toolname in ['portal_creditcard'] \
                                      if toolname not in navtreeProperties.idsNotToList]:
                if toolname in navtreeProperties.idsNotToList:
                    navtreeProperties.idsNotToList.remove(toolname)

    #if uninstall:
    #    print >>out,'Custom Uninstall:'
    #    res = uninstall(self)
    #    if res:
    #        print >>out,res
    #    else:
    #        print >>out,'no output'
    #else:
    #    print >>out,'no custom uninstall'

    return out.getvalue()
