from Globals import package_home
from Products.CMFCore import utils, CMFCorePermissions, DirectoryView
from Products.Archetypes.public import *
from Products.Archetypes import listTypes
from Products.Archetypes.utils import capitalize
from Products.CMFCore.utils import ToolInit
from Products.SFUAuthorizeNetPlugin.config import *
import AuthorizeNet
import os, os.path

DirectoryView.registerDirectory('skins', product_globals)
DirectoryView.registerDirectory('skins/SFUAuthorizeNetPlugin_public', product_globals)


def initialize(context):
    ##Import Types here to register them
    import AuthorizeNet
    import AuthorizeNetSettings
    import AuthorizeNetPaymentInformation
    import CreditCardTool
    
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

# Initialize Credit Card Tool
    tools = ( CreditCardTool.CreditCardTool,)
    ToolInit( 'Credit Card Tool'
            , tools=tools
            , product_name=PROJECTNAME
            , icon='tool.gif'
            ).initialize( context )


    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    
    # and now give it some extra permissions so that i
    # can control them on a per class limit
    for i in range(0,len(content_types)):
        perm='Add '+ capitalize(ftis[i]['id'])+'s'
        methname='add'+capitalize(ftis[i]['id'])
        meta_type = ftis[i]['meta_type']

        context.registerClass(
            meta_type=meta_type,
            constructors = (
                            getattr(locals()[meta_type],'add'+capitalize(meta_type)),
                               )
            , permission = perm
            )

#try:
#    import CustomizationPolicy
#except ImportError:
#    CustomizationPolicy=None
#

#    if CustomizationPolicy and hasattr(CustomizationPolicy,'register'):
#        CustomizationPolicy.register(context)
#        print 'Customizationpolicy for AuthorizeNet installed'

