r = context.REQUEST
s = r.SESSION

s['cardnumber'] = r['cardnumber']
s['expdate'] = r['expdate']

order_id = s['order_id']
pom = context.portal_ordermanager
order = pom.getOrderById(order_id)

addressinfoset = order['address_information_set']
address = addressinfoset['address_information']  # what happens with multiple addresses? how would we handle that?
shipping_address = addressinfoset['shipping_address_information']

customer = order.getCustomer()

## get the payment settings
payment = order.getPayment()
settings = payment.getSettings()

# build a dictionary of necessary authorize.net info
cust = {}

cust['first_name']     = customer.getFirstname()
cust['last_name']      = customer.getLastname()
cust['email']          = customer.getEmail()
cust['phone']          = customer.getHomePhoneNumber()
# billing address
cust['address1']       = address.getAddress1()
cust['address2']       = address.getAddress2()  ## this doesn't get passed to auth.net
cust['city']           = address.getCity()
cust['home_state']     = address.getState()
cust['country']        = address.getCountry()
cust['zip']            = address.getPostal_code()
# shipping address
cust['ship_address1']  = shipping_address.getAddress1()
cust['ship_address2']  = shipping_address.getAddress2()  ## this doesn't get passed to auth.net
cust['ship_city']      = shipping_address.getCity()
cust['ship_home_state']= shipping_address.getState()
cust['ship_country']   = shipping_address.getCountry()
cust['ship_zip']       = shipping_address.getPostal_code()
cust['company']        = ""
cust['customer_ip']    = r['REMOTE_ADDR']
cust['card']           = r['cardnumber']
cust['expires']        = r['expdate']
cust['x_login']        = settings.getXLogin()
cust['x_tran_key']     = settings.getXTranKey()
cust['version']        = settings.getXVersion()
cust['test']           = settings.getXTestRequest()
cust['x_email_customer'] = settings.getXEmailCustomer()
cust['amount']         = str(order.getTotal())
cust['description']    = "%s - Order #%s" % (context.portal_url.Title(), order_id)
cust['x_invoice_num']  = "%s" % order_id


# declare a payment
pstate = context.portal_workflow.getInfoFor(payment, 'review_state')
if pstate != 'processing':
    payment.changeState('startProcessing')
result, error = context.portal_creditcard.doAuthCapture(cust)

context.plone_log("\n*******\nOrder #%s\nResult: %s\nError: %s\n*******\n" % (order_id, result, error))

if result == 'approved':
    context.plone_log("\n*******\nOrder #%s succeeded\n*******\n" % order_id)
    payment.paymentSuccess()
else:
    context.plone_log("\n*******\nOrder #%s failed\n*******\n" % order_id)
    # if this gets set to failure you can't retry the payment
    #payment.changeState('failureProcessing')
    state.setError('cardnumber', error, new_status='failure')
    state.set(portal_status_message=error)
    return state
